decodecode 1.89 KB
Newer Older
1 2 3 4 5 6 7 8
#!/bin/sh
# Disassemble the Code: line in Linux oopses
# usage: decodecode < oops.file
#
# options: set env. variable AFLAGS=options to pass options to "as";
# e.g., to decode an i386 oops on an x86_64 system, use:
# AFLAGS=--32 decodecode < 386.oops

9
cleanup() {
10
	rm -f $T $T.s $T.o $T.oo $T.aa $T.dis
11 12 13 14 15 16 17 18 19 20 21
	exit 1
}

die() {
	echo "$@"
	exit 1
}

trap cleanup EXIT

T=`mktemp` || die "cannot create temp file"
22 23 24 25 26 27 28 29 30 31 32 33 34
code=

while read i ; do

case "$i" in
*Code:*)
	code=$i
	;;
esac

done

if [ -z "$code" ]; then
35
	rm $T
36 37 38 39 40 41
	exit
fi

echo $code
code=`echo $code | sed -e 's/.*Code: //'`

42
width=`expr index "$code" ' '`
43
width=$((($width-1)/2))
44 45 46 47 48 49 50
case $width in
1) type=byte ;;
2) type=2byte ;;
4) type=4byte ;;
esac

disas() {
51
	${CROSS_COMPILE}as $AFLAGS -o $1.o $1.s > /dev/null 2>&1
52

53 54
	if [ "$ARCH" = "arm" ]; then
		if [ $width -eq 2 ]; then
55 56 57 58 59 60 61
			OBJDUMPFLAGS="-M force-thumb"
		fi

		${CROSS_COMPILE}strip $1.o
	fi

	${CROSS_COMPILE}objdump $OBJDUMPFLAGS -S $1.o | \
62
		grep -v "/tmp\|Disassembly\|\.text\|^$" > $1.dis 2>&1
63 64
}

65 66 67 68 69
marker=`expr index "$code" "\<"`
if [ $marker -eq 0 ]; then
	marker=`expr index "$code" "\("`
fi

70
touch $T.oo
71
if [ $marker -ne 0 ]; then
72 73 74
	echo All code >> $T.oo
	echo ======== >> $T.oo
	beforemark=`echo "$code"`
75 76 77 78 79
	echo -n "	.$type 0x" > $T.s
	echo $beforemark | sed -e 's/ /,0x/g; s/[<>()]//g' >> $T.s
	disas $T
	cat $T.dis >> $T.oo
	rm -f $T.o $T.s $T.dis
80 81 82 83

# and fix code at-and-after marker
	code=`echo "$code" | cut -c$((${marker} + 1))-`
fi
84 85
echo Code starting with the faulting instruction  > $T.aa
echo =========================================== >> $T.aa
86 87
code=`echo $code | sed -e 's/ [<(]/ /;s/[>)] / /;s/ /,0x/g; s/[>)]$//'`
echo -n "	.$type 0x" > $T.s
88
echo $code >> $T.s
89 90
disas $T
cat $T.dis >> $T.aa
91

92
faultline=`cat $T.dis | head -1 | cut -d":" -f2-`
93
faultline=`echo "$faultline" | sed -e 's/\[/\\\[/g; s/\]/\\\]/g'`
94 95 96 97 98

cat $T.oo | sed -e "s/\($faultline\)/\*\1     <-- trapping instruction/g"
echo
cat $T.aa
cleanup